Changelog for: GameSpy Server Browsing SDK
--------------------------------------------------------

DATE        VERSION  BY   TYPE     DESCRIPTION
----------  -------  ---  -------  ---------------------------------------------------------
12-12-2007  2.07.00  RMV  RELEASE  Released to Developer Site
12-11-2007  2.06.05  SAH  OTHER    Added NatNeg files to projects to remove compiler errors
11-27-2007  2.06.03  SAH  CLEANUP  Moved extern "c" block below includes to prevent linker errors
11-21-2007  2.06.02  SAH  FIX      Added NNFreeNegotiateList to ServerBrowserFree function
11-05-2007  2.06.01  DES  FEATURE  Added ServerBrowserConnectToServer (ACE functionality)
08-06-2007  2.06.00  RMV  OTHER    Modified sbctest, making it more thorough and developer friendly (and added ReadMe)
08-06-2007  2.06.00  RMV  RELEASE  Released to Developer Site
07-10-2007  2.05.04  RMV  FIX      Fixed test project files to get rid of Unicode warnings and fixed other compiler warnings
05-16-2007  2.05.03  DES  FIX      Changed use of u_char to gsi_u8
                     DES  FEATURE  ICMP support is now included by default, define SB_NO_ICMP_SUPPORT to exclude it
01-25-2007  2.05.02  SAH  FIX      Fixed a bug where the country/region keys would be queried for by individual servers
01-16-2007  2.05.01  DES  FEATURE  Added X360 support
12-15-2006  2.05.00  MJW  RELEASE  Released to Developer Site
11-10-2006  2.04.36  JR   RELEASE  Limited release
10-23-2006  2.04.36  DES  RELEASE  Limited release
10-11-2006  2.04.36  SN   FIX      Fixed case where possible disconnection could corrupt input buffer when there 
                                   was still data on the buffer.
10-05-2006  2.04.35  SAH  FIX      Updated MacOSX Makefile
09-28-2006  2.04.34  SAH  FIX      Fixed PS3 project to work with PS3 095.00x SDK; changed included libaries in linker input.
08-18-2006  2.04.33  SN   FIX      Fixed ServerBrowserAuxUpdateIP where servers not pending queries were marked 
                                   with duplicate query error
08-02-2006  2.04.32  SAH  RELEASE  Releasing to developer site
07-31-2006  2.04.32  SAH  FIX      Fixed PS3 project file - added post-build step to create *.SELF for execution
07-25-2006  2.04.31  SAH  FIX      Fixed NITRO project, include for crt0.o now above others so it add correct file
07-24-2006  2.04.30  SAH  FIX      Added newline at EOF to sb_serverbrowsing.c to fix compilation warning
                     SAH  FIX      Removed #ifdef _PS3 for socket calls (changed platformSocket.h to typecast calls)
07-06-2006  2.04.29  SAH  FIX      Changed a break; to a return; for challenge received when calling auxUpdateIP synchronously
                     SAH  FIX      Made Querytest.c use test_main like our other SDKs, edited project appropriately
07-06-2006  2.04.28  SAH  FIX      Fixed PSP project file to not explicitly include the PSP linker file
07-06-2006  2.04.27  SAH  FIX      Fixed linux makefile to work with pthreads (for http asynch DNS lookup)
06-30-2006  2.04.26  SAH  FIX      Changed natneg = 1 to SBTrue to get rid of warnings
                     SAH  FIX      Fixed NITRO project && linker command file (for Codewarrior 2.0/NitroSDK 3.1)
06-30-2006  2.04.25  MJ   FEATURE  Added SBServerGetConnectionInfo
05-31-2006  2.04.24  SAH  RELEASE  Releasing to developer site
                     SAH  FIX      Fixed Linux makefile
05-30-2006  2.04.24  SAH  FIX      Fixed PS3 projects to work with PS3(084_001 SDK)
05-25-2006  2.04.24  SAH  FIX      Changed PSP project warning levels
05-24-2006  2.04.23  SAH  FIX      added sbe_duplicateupdateerror case to switch statement
05-23-2006  2.04.22  BED  FIX      AuxUpdate functions will no longer update a server while an update is already pending
05-23-2006  2.04.21  SAH  FIX      Added win32common.c and gsTestMain.c to sbctest project 
05-23-2006  2.04.20  SAH  FIX      Added GS_STATIC_CALLBACK to compare functions for __fastcall support
05-19-2006  2.04.19  SAH  FIX      Added gsTestMain.c for nitro CodeWarrior project
05-15-2006  2.04.18  SAH  FIX      Added "PS3 Release" configuration to project
04-25-2006  2.04.17  SAH  RELEASE  Releasing to developer site
04-24-2006  2.04.17  SAH  FIX      Fixed UNICODE compile errors, mainly typecasts
04-24-2006  2.04.16  SAH  FIX      Fixed SortInfo creation call, fixed Nitro project files to work on build machine
04-20-2006  2.04.15  SAH  FIX      Removed unnecessary break; statements, added some (char*) typecasts
                     SAH  FIX      Moved GSI_UNUSED calls above return statements
04-20-2006  2.04.14  SAH  FIX      Added _PS3 wrapper typecast for recvfrom calls
04-19-2006  2.04.13  SAH  FIX      Added || defined(_PS3) to sbctest.c for PS3 Support
04-13-2006  2.04.12  SAH  FIX      Added parenthesis to remove compiler warnings before Release	
04-10-2006  2.04.11  SAH  FEATURE  Multiple sorts will retain previous sorting arrangement when values are equal
03-28-2006  2.04.10  SN   FIX      Added extra checks to account for empty keys
03-28-2006  2.04.10  SN   FIX      Fixed SBServerGetIntValue to return negative numbers
03-20-2006  2.04.09  SN   OTHER    Added PSP to the defines before the test_main in sbctest
                     SN   OTHER    Moved the GSI_UNUSED calls to before the return statement
01-27-2006  2.04.09  SN   RELEASE  Releasing to developer site
01-27-2006  2.04.09  SN   FIX      Added psp prodg project and solution to sgv
12-22-2005  2.04.08  SN   OTHER    Cleaned up project files and added missing common code.
11-17-2005  2.04.07  DES  FIX      Compatibility fixes.
                     DES  FIX      Updated Nitro Makefile.
11-14-2005  2.04.06  DES  FIX      Updated OSX support.
                     DES  FEATURE  Added GSI_DOMAIN_NAME support.
10-12-2005  2.04.05  BED  RELEASE  Releasing to developer site.
10-11-2005  2.04.04  BED  FEATURE  Added query challege/response to prevent ip spoofing.
09-23-2005  2.04.03  DES  FEATURE  Updated DS support
                     DES  FIX      Fixed SBServerGetBoolValue() to return the default is the value is empty
07-28-2005  2.04.02  SN   RELEASE  Releasing to developer site.
06-28-2005  2.04.02  BED  FEATURE  Added ICMP support for remaining platforms.
06-03-2005  2.04.01  SN   RELEASE  Releasing to developer site.
05-05-2005  2.04.01  BED  FIX      Updated projects to use new common folder.
o5-04-2005  2.04.00  SN   OTHER    Created Visual Studio .NET projects
04-29-2005  2.04.00  BED  FEATURE  Added support for multi-packet qr2 responses. (Full keys direct only)
04-28-2005  2.03.03  SN   RELEASE  Releasing to developer site.
04-27-2005  2.03.03  DES  RELEASE  Limited release to Nintendo DS developers.
04-27-2005  2.03.03  DES  FEATURE  Modified sbctest to quit when the update is complete.
04-25-2005  2.03.02  DES  FIX      Fixed a function call in querytest.
04-21-2005  2.03.01  DES  FIX      Renamed IPHeader and ICMPHeader to avoid Nitro header conflict.
04-18-2005  2.03.00  DDW  FEATURE  Added initial Win32 support for ICMP pings of firewalled servers
                          FEATURE  Added new SBServerHasValidPing public function        
04-04-2005  2.02.21  SN   RELEASE  Releasing to developer site.
03-14-2005  2.02.21  DES  FEATURE  Nintendo DS support
02-17-2005  2.02.20  DDW  OTHER    Extended gamenames in SB structures to 36 bytes from 32 (dynamic gamename support)
01-27-2005  2.02.19  DES  FIX      Fixed custom SN sendto and moved it to nonport
11-03-2004  2.02.18  SN   FIX      Fixed and turned off availability check during LAN browsing,
                     SN   FIX      Added a check to a server object when obtaining key values
                     SN   FIX      Updated SBMFC sample to have new ServerBrowserNew function
09-27-2004  2.02.17  SN   RELEASE  Releasing qr2 fix to developer site
09-16-2004  2.02.16  SN   RELEASE  Releasing to developer site.
09-08.2004  2.02.16  BED  FIX      Fixed cases where same server could appear in FIFO multiple times
08-27-2004  2.02.15  DES  CLEANUP  Fixed warnings under OSX
                     DES  CLEANUP  Updated Win32 project configurations
                     DES  CLEANUP  Removed #pragma comment for linking with winsock (in nonport now)
                     DES  CLEANUP  General Unicode cleanup
                     DES  CLEANUP  Removed MacOS style includes
                     DES  FEATURE  Added OSX Makefile
08-25-2004  2.02.14  DES  FEATURE  Added OSX makefile
08-04-2004  2.02.13  SN   RELEASE  Releasing to developer site.
07-12-2004  2.02.13  SN   FIX      Cleared errors when warnings are treated as errors set, and warning level is highest.  
06-18-2004  2.02.12  BED  RELEASE  Releasing to developer site.
06-16-2004  2.02.12  BED  FEATURE  PS2 Insock configurations added to samples.
05-24-2004  2.02.11  BED  FIX      ServerBrowserAuxUpdateIP no longer adds a duplicate SBServer to the list
05-22-2004  2.02.10  BED  FEATURE  Ps2 Insock support added.
05-21-2004  2.02.09  DDW  FEATURE  VEngine & Peer compatibility fix - now local to each serverlist
05-14-2004  2.02.08  DDW  FEATURE  VEngine & Peer compatibility fix
05-06-2004  2.02.07  DDW  FEATURE  Allow external management of the unique string hash
05-06-2004  2.02.06  BED  FIX      SBServerGetIntValue now returns <default> instead of 0 for a key that is empty-string.
04-02-2004  2.02.05  BED  FIX      Capped max recvfrom size to 2048 for PS2 INSOCK compatibility.
                     BED  FEATURE  Added ability to specify network adapter when LAN browsing.
                     BED  FIX      Changed "unsigned long" to "gsi_time" in a couple places for PS2 compatability.
03-30-2004  2.02.04  BED  FIX      Fixed timing issue where server might appear twice in the FIFO, causing a crash.
03-19-2004  2.02.03  BED  FEATURE  Added ability to specify network adapter when LAN browsing.
03-09-2004  2.02.02  BED  FIX      Fixed case where browsing would not complete when all servers were behind a firewall.
01-12-2004  2.02.01  BED  FEATURE  Added ServerBrowserGetServerByIP for IP lookup into the list.
01-07-2004  2.02.00  DDW  FEATURE  Added internal support for player searching
01-07-2004  2.01.01  BED  FIX	   Added prototypes for ascii functions in UNICODE mode.
12-16-2003  2.01.00  DDW  FEATURE  Added internal support for map loop lookup
11-10-2003  2.00.36  DES  RELEASE  Releasing to developer site.
11-10-2003  2.00.36  BED  FIX      Fixed case where LAN browsing would never complete.
11-07-2003  2.00.35  BED  FIX      Update CodeWarrior project file.
11-07-2003  2.00.35  DES  FIX      Updated linux and PS2 makefiles.
11-06-2003  2.00.34  BED  FIX      Fixed case where raw buffer was treated as string (unicode conversion doesn't apply)
11-04-2003  2.00.33  BED  FIX      Added some const-correctness to the SDK.
                     BED  FIX      Removed misc warnings for devstudio level 4.
11-04-2003  2.00.32  DES  FEATURE  Added availability check code.
10-22-2003  2.00.31  BED  RELEASE  Releasing to developer site.  (UNIQUE NICK AND UNICODE SUPPORT)
10-22-2003  2.00.31  BED  FIX      Removed some compiler warnings on scrict setting.
10-21-2003  2.00.30  DES  FIX      Added stringutil files to VC++ sample projects.
10-09-2003  2.00.29  BED  FIX      Switched to gsi_time type instead of unsinged long for PS2 compatibility
09-09-2003  2.00.28  BED  FEATURE  Added UTF-8 wrapper -- define GSI_UNICODE
                          OTHER    Added stringutil.c and stringutil.h to sample project files
08-06-2003  2.00.27  BED  FIX      Increased sb_serverlist.c incoming UDP buffer size from 500 to 1500 bytes.
07-29-2003  2.00.26  BED  FIX      Fixed calls in sb_server.c where integers (#2) were being returned instead of SBBool.
07-24-2003  2.00.25  DES  RELEASE  Releasing to developer site.
07-18-2003  2.00.25  BED  FEATURE  Added CodeWarrior (PS2) sample project file.
                     BED  CLEANUP  General cleanup to remove CodeWarrior warnings.
07-17-2003  2.00.24  DES  CLEANUP  Cleaned up the PS2 Makefile, it now uses Makefile.commmon.
07-16-2003  2.00.23  DES  FIX      Changed a couple of __mips64 checks to _PS2 checks.
                     BED  FEATURE  Added ProDG sample project files.
07-09-2003  2.00.22  BED  CLEANUP  Made MFC sample's server list not continually redraw while sorting.
06-11-2003  2.00.21  DES  RELEASE  Releasing to developer site.
05-11-2003  2.00.21  DDW  CLEANUP  Modularized SBServer type handling
05-11-2003  2.00.20  DDW  CLEANUP  Modularized server parsing and addition
05-09-2003  2.00.19  DES  CLEANUP  Removed Dreamcast support.
05-09-2003  2.00.18  DDW  CLEANUP  Modularized refstrings and serverlist functions
05-07-2003  2.00.17  DES  RELEASE  Releasing to developer site.
04-07-2003  2.00.17  DES  FIX      Fixed semicolon after if() in SBServerListFindServer.
03-24-2003  2.00.16  DDW  FEATURE  Added ServerBrowserLimitUpdate function to limit the number of results returned
03-03-2003  2.00.15  DES  CLEANUP  General cleanup to remove warnings.
02-28-2003  2.00.14  DES  RELEASE  Releasing to developer site with updated QR2.
02-05-2003  2.00.14  DES  RELEASE  Releasing to developer site.
02-05-2003  2.00.14  DES  FIX      Made sure servers in MFC sample show correct info after an sbc_serverupdated.
                          CLEANUP  Switched select calls to CanReceiveOnSocket and CanSendOnSocket.
02-04-2003  2.00.13  DES  RELEASE  Relasing to developer site.
02-04-2003  2.00.13  DES  CLEANUP  Removed assert.h include from querytest.c
                          FIX      Use GOA/QR2 checkbox in the MFC sample.
                          OTHER    Show servers in the MFC sample as soon as they are added (sbc_serveradded).
01-23-2003  2.00.12  DES  FIX      Replaced a call to free with gsifree.
12-19-2002  2.00.11  DES  RELEASE  Releasing to developer site.
12-19-2002  2.00.11  DES  CLEANUP  Removed assert.h includes.
12-13-2002  2.00.10  DES  FEATURE  Added PS2 eenet stack support.
12-06-2002  2.00.09  DES  RELEASE  Releasing to developer site with updated QR2.
12-03-2002  2.00.09  DES  RELEASE  Releasing to developer site.
12-03-2002  2.00.09  DES  FEATURE  Added a Linux Makefile.
11-22-2002  2.00.08  DES  RELEASE  Releasing to developer site.
11-20-2002  2.00.08  DES  FEATURE  Added support for compiling on the PS2.
11-15-2002  2.00.07  DDW  FEATURE  Abstracted the server->next pointer into SBServer.c
11-07-2002  2.00.06  DDW  FEATURE  Added "deadlist" support so that servers are not freed on the same pass they are removed
11-07-2002  2.00.06  DDW  FIX      Fixed AV when disconnecting during mainlist with data pending
10-22-2002  2.00.05  DDW  FIX      Correctly removes server from query engine when removed message arrives
09-26-2002  2.00.04  DES  RELEASE  Limited release on developer site
09-26-2002  2.00.04  DDW  FIX      MFC sample checks whether server has full-rules before requerying
09-26-2002  2.00.03  DES  FEATURE  Added MFC sample (sbmfcsample)
09-26-2002  2.00.02  DDW  OTHER    Changelog started
09-26-2002  2.00.02  DES  FIX      Fixed memory leak when cleaning up server list object
09-24-2002  2.00.01  DDW  FIX      Fixed protocol parsing error on packet boundary
09-23-2002  2.00.00  DDW  RELEASE  Release to EAPAC for Generals (Peer)
09-06-2002  2.00.00  DDW  RELEASE  Release to EAPAC for Generals

